## libgd2 2.2.5

=== src/CMakeLists.txt ===

SET (LIBGD_SRC_FILES
	bmp.h
	gd.c
	gd.h
	gd_bmp.c
	gd_color.c
	gd_color.h
	gd_color_map.c
	gd_color_map.h
	gd_color_match.c
	gd_crop.c
	gd_filename.c
	gd_filter.c
	gd_gd.c
	gd_gd2.c
	gd_gif_in.c
	gd_gif_out.c
	gd_intern.h
	gd_interpolation.c
	gd_io.c
	gd_io.h
	gd_io_dp.c
	gd_io_file.c
	gd_io_ss.c
	gd_io_stream.cxx
	gd_io_stream.h
	gd_jpeg.c
	gd_matrix.c
	gd_nnquant.c
	gd_nnquant.h
	gd_png.c
	gd_rotate.c
	gd_security.c
	gd_ss.c
	gd_tga.c
	gd_tga.h
	gd_tiff.c
	gd_topal.c
	gd_transform.c
	gd_version.c
	gd_wbmp.c
	gd_webp.c
	gd_xbm.c
	gdcache.c
	gdcache.h
	gdfontg.c
	gdfontg.h
	gdfontl.c
	gdfontl.h
	gdfontmb.c
	gdfontmb.h
	gdfonts.c
	gdfonts.h
	gdfontt.c
	gdfontt.h
	gdft.c
	gdfx.c
	gdfx.h
	gdhelpers.c
	gdhelpers.h
	gdkanji.c
	gdpp.cxx
	gdpp.h
	gdtables.c
	gdxpm.c
	jisx0208.h
	wbmp.c
	wbmp.h
)

if(MSVC AND MSVC_VERSION LESS 1900)
	set(LIBGD_SRC_FILES ${LIBGD_SRC_FILES}
		snprintf.c
	)
endif(MSVC AND MSVC_VERSION LESS 1900)

include(GNUInstallDirs)

if (BUILD_SHARED_LIBS)
	add_library(${GD_LIB} ${LIBGD_SRC_FILES})
	set_target_properties(${GD_LIB} PROPERTIES
		C_VISIBILITY_PRESET hidden
		CXX_VISIBILITY_PRESET hidden
	)
endif()

if (BUILD_STATIC_LIBS)
	add_library(${GD_LIB_STATIC} STATIC ${LIBGD_SRC_FILES})
	if (UNIX)
		set_target_properties(${GD_LIB_STATIC} PROPERTIES OUTPUT_NAME ${GD_LIB})
	endif()
endif()

if (WIN32 AND NOT MINGW AND NOT MSYS)
  #	SET_TARGET_PROPERTIES(${GD_LIB} PROPERTIES LINK_FLAGS "/NODEFAULTLIB:msvcrt.lib")
  SET_PROPERTY(TARGET ${GD_LIB_STATIC} APPEND PROPERTY COMPILE_DEFINITIONS NONDLL=1)
ENDIF(WIN32 AND NOT MINGW AND NOT MSYS)

if (MINGW OR MSYS)
	ADD_DEFINITIONS("-mms-bitfields")
	set_target_properties(${GD_LIB_STATIC} PROPERTIES OUTPUT_NAME ${GD_LIB})
endif (MINGW OR MSYS)

INCLUDE_DIRECTORIES(BEFORE "${PROJECT_BINARY_DIR}" "${CMAKE_BINARY_DIR}" "${GD_SOURCE_DIR}/src")

SET(LIBGD_DEP_LIBS
	${ZLIB_LIBRARIES}
	${FREETYPE_LIBRARIES}
	${PNG_LIBRARIES}
	${ICONV_LIBRARIES}
	${LIQ_LIBRARIES}
	${JPEG_LIBRARIES}
	${TIFF_LIBRARIES}
	${XPM_LIBRARIES}
	${FONTCONFIG_LIBRARY}
	${WEBP_LIBRARIES}
)
if (BUILD_SHARED_LIBS)
	target_link_libraries(${GD_LIB} ${LIBGD_DEP_LIBS})
endif()
if (BUILD_STATIC_LIBS)
	target_link_libraries(${GD_LIB_STATIC} ${LIBGD_DEP_LIBS})
endif()

set(GD_PROGRAMS gdcmpgif)

if (PNG_FOUND)
	set(GD_PROGRAMS ${GD_PROGRAMS} gdtopng pngtogd webpng)
	if (ZLIB_FOUND)
		set(GD_PROGRAMS ${GD_PROGRAMS} gdparttopng gd2topng pngtogd2)
	endif()
endif()

if (FREETYPE_FOUND)
	set(GD_PROGRAMS ${GD_PROGRAMS} annotate)
endif()

if (ZLIB_FOUND)
	set(GD_PROGRAMS ${GD_PROGRAMS} gd2copypal gd2togif giftogd2)
endif()

foreach(program ${GD_PROGRAMS})
    add_executable(${program} ${program}.c)
    if (BUILD_SHARED_LIBS)
        target_link_libraries(${program} ${GD_LIB})
    else()
        target_link_libraries(${program} ${GD_LIB_STATIC})
    endif()
endforeach(program)

set(GD_INSTALL_TARGETS ${GD_PROGRAMS})
if (BUILD_SHARED_LIBS)
	set(GD_INSTALL_TARGETS ${GD_INSTALL_TARGETS} ${GD_LIB})
endif()
if (BUILD_STATIC_LIBS)
	set(GD_INSTALL_TARGETS ${GD_INSTALL_TARGETS} ${GD_LIB_STATIC})
endif()

install(TARGETS ${GD_INSTALL_TARGETS}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(PROGRAMS bdftogd DESTINATION bin)
install(FILES
	entities.h
	gd.h
	gd_color_map.h
	gd_errors.h
	gd_io.h
	gdcache.h
	gdfontg.h
	gdfontl.h
	gdfontmb.h
	gdfonts.h
	gdfontt.h
	gdfx.h
	gdpp.h
	DESTINATION include)

=== tests/CMakeLists.txt ===

if (BUILD_TEST)
	SET(DART_TESTING_TIMEOUT 5)

	INCLUDE(Dart)

	set(GDTEST_SOURCE_DIR ${GD_SOURCE_DIR}/tests/gdtest)

	IF (ENABLE_GCOV AND CMAKE_COMPILER_IS_GNUCC)
		SET(CMAKE_BUILD_TYPE TESTINGGCOV)
		SET(CMAKE_CXX_FLAGS_TESTINGGCOV "-g3 -O0")
		SET(CMAKE_C_FLAGS_TESTINGGCOV "-g3 -O0")
	endif (ENABLE_GCOV AND CMAKE_COMPILER_IS_GNUCC)

	message(STATUS "gd include dir: ${GD_INCLUDE_DIR}" )
	message(STATUS "gd libs dir: ${GD_LIBS_DIR}" )

	include_directories (BEFORE ${GD_INCLUDE_DIR} "${GDTEST_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" "${CMAKE_BINARY_DIR}/tests/gdtest")

	SET(TESTS_DIRS
		bmp
		fontconfig
		freetype
		gd
		gd2
		gdimagearc
		gdimagebrightness
		gdimageclone
		gdimagecolor
		gdimagecolorclosest
		gdimagecolordeallocate
		gdimagecolorexact
		gdimagecolorreplace
		gdimagecolorresolve
		gdimagecolortransparent
		gdimagecontrast
		gdimageconvolution
		gdimagecopy
		gdimagecopyresampled
		gdimagecopyrotated
		gdimagecreate
		gdimagecrop
		gdimagefile
		gdimagefill
		gdimagefilledarc
		gdimagefilledellipse
		gdimagefilledpolygon
		gdimagefilledrectangle
		gdimagefilltoborder
		gdimagefilter
		gdimageflip
		gdimagegrayscale
		gdimageline
		gdimagenegate
		gdimageopenpolygon
		gdimagepixelate
		gdimagepolygon
		gdimagerectangle
		gdimagerotate
		gdimagescale
		gdimagescatterex
		gdimagesetpixel
		gdimagestringft
		gdimagestringftex
		gdimagetruecolortopalette
		gdinterpolatedscale
		gdnewfilectx
		gdtest
		gdtiled
		gdtransformaffineboundingbox
		gif
		jpeg
		png
		tga
		tiff
		wbmp
		webp
		xbm
		xpm
	)

	FOREACH(test_dir ${TESTS_DIRS})
		add_subdirectory (${test_dir})
	ENDFOREACH(test_dir)

endif (BUILD_TEST)

=== tests/bmp/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bmp_null
	bug00275
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bmp_im2im
	bug00276
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gd/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	gd_null
	gd_num_colors
	gd_versiontest
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	gd_im2im
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gd2/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bug_289
	bug00209
	bug00309
	bug00354
	gd2_empty_file
	php_bug_72339
	gd2_read_corrupt
	too_few_image_data
)

IF(ZLIB_FOUND)
LIST(APPEND TESTS_FILES
	gd2_null
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	gd2_im2im
	gd2_read
)
ENDIF(PNG_FOUND)
ENDIF(ZLIB_FOUND)

ADD_GD_TESTS()

=== tests/gdimagecrop/CMakeLists.txt ===
SET(TESTS_FILES
	bug00297
	php_bug_72494
)

ADD_GD_TESTS()

=== tests/gdimagefill/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00002_1
	bug00002_2
	bug00002_3
	bug00002_4
	bug00104_1
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gif/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bug00005_2
	bug00181
	bug00227
	gif_null
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00005
	bug00006
	bug00060
	bug00066
	gif_im2im
	uninitialized_memory_read
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/tiff/CMakeLists.txt ===
IF(TIFF_FOUND)
LIST(APPEND TESTS_FILES
	tiff_im2im
	tiff_invalid_read
	tiff_null
	tiff_dpi
	tiff_read_bw
)
ENDIF(TIFF_FOUND)

ADD_GD_TESTS()

=== tests/webp/CMakeLists.txt ===
IF(WEBP_FOUND)
LIST(APPEND TESTS_FILES
	bug00111
	bug_double_free
)
ENDIF(WEBP_FOUND)

ADD_GD_TESTS()

=== debian/changelog ===
libgd2 (2.2.5-4) unstable; urgency=medium

  [ Jiří Paleček ]
  * Disable the test during build and run the testsuite through autopkgtest
    (Closes: #867003)
  * Make --as-needed work again

  [ Ondřej Surý ]
  * Get rid of libgd2*-dev traces (Closes: #879254)

 -- Ondřej Surý <ondrej@debian.org>  Sun, 22 Oct 2017 11:14:32 +0200

libgd2 (2.2.5-3) unstable; urgency=medium

  * Disable gdimagerotate/bug00067 because it FTBFS on i386

 -- Ondřej Surý <ondrej@debian.org>  Tue, 05 Sep 2017 13:46:57 +0200

libgd2 (2.2.5-2) unstable; urgency=medium

  * Fix OOB read due to crafted GD/GD2 images
  * Disable gdimagecopyresampled/bug00201 that makes some platforms to FTBFS

 -- Ondřej Surý <ondrej@debian.org>  Mon, 04 Sep 2017 09:43:31 +0200

libgd2 (2.2.5-1) unstable; urgency=high

  * New upstream version 2.2.5
   + [CVE-2017-6362]: Double-free in gdImagePngPtr().
   + [CVE-2017-7890]: Buffer over-read into uninitialized memory.
  * Update d/watch for the github releases
  * Refresh patches for the 2.2.5 release

 -- Ondřej Surý <ondrej@debian.org>  Wed, 30 Aug 2017 14:21:43 +0200

=== debian/control ===
Source: libgd2
Section: graphics
Priority: optional
Maintainer: GD team <pkg-gd-devel@lists.alioth.debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>
Build-Depends: autotools-dev,
	       debhelper (>= 9),
	       libpng-dev,
	       libz-dev,
	       libjpeg-dev,
	       libfreetype6-dev,
	       libxpm-dev,
	       libx11-dev,
	       libxt-dev,
	       libfontconfig-dev,
	       libwebp-dev,
	       libtiff-dev,
	       dh-autoreconf,
	       html2text
Vcs-Git: git://anonscm.debian.org/collab-maint/libgd2.git
Vcs-Browser: http://anonscm.debian.org/gitweb?p=collab-maint/libgd2.git;a=summary
Standards-Version: 3.9.3
Homepage: http://www.libgd.org/

Package: libgd-tools
Architecture: any
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Suggests: libgd-dev
Description: GD command line tools and example code
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is some simple command line tools and example code that use the GD
 graphics library.

Package: libgd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgd3 (= ${binary:Version}),
	 ${misc:Depends},
	 libpng-dev,
	 libz-dev,
	 libjpeg-dev,
	 libfreetype6-dev,
	 libxpm-dev,
	 libx11-dev,
	 libxt-dev,
	 libfontconfig-dev,
	 libvpx-dev,
	 libtiff-dev
Description: GD Graphics Library (development version)
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is the full development version of the library.

Package: libgd3
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libgd-tools
Description: GD Graphics Library
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is the runtime package of the library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
# DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@ --with autoreconf

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- --disable-rpath --with-tiff=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

override_dh_install:
	dh_install --fail-missing -Xlibgd.la -Xgdlib-config

override_dh_strip:
	dh_strip -O--dbgsym-migration='libgd-dbg (<< 2.2.3-87-gd0fec80-1)'

override_dh_auto_test:

## libgd2 2.2.5.3

=== tests/gdimagecolorexact/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	gdimagecolorexact
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagefilledarc/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	php_bug43828
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== debian/changelog ===
libgd2 (2.2.5.3-1+dde) unstable; urgency=medium

  * update

 -- GD Team <team+gd@tracker.debian.org>  Thu, 23 Sep 2021 17:59:07 +0800

libgd2 (2.2.5.3-1+dde) oldstable; urgency=medium

  * fix CVE-2021-40145

 -- Clay Stan <claystan97@gmail.com>  Thu, 09 Sep 2021 13:43:44 +0800

libgd2 (2.2.5.2-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2017-6363

 -- zhouzilong <zhouzilong@uniontech.com>  Wed, 16 Sep 2020 21:02:13 +0800

libgd2 (2.2.5.1-1+dde) unstable; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2019-11038: Uninitialized read in gdImageCreateFromXbm
    (Closes: #929821)

 -- Jonas Meurer <jonas@freesources.org>  Tue, 11 Jun 2019 16:21:57 +0200

libgd2 (2.2.5-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Heap-based buffer overflow in gdImageColorMatch (CVE-2019-6977)
    (Closes: #920645)
  * Potential double-free in gdImage*Ptr() (CVE-2019-6978) (Closes: #920728)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 02 Feb 2019 10:55:00 +0100

libgd2 (2.2.5-5) unstable; urgency=medium

  * Update Vcs-* links to salsa.d.o
  * Update maintainers address to team+gd@tracker.d.o (Closes: #899928)
  * Remove Files-Excluded from d/copyright, the files just inherit the
    global license (Closes: #883760)

 -- Ondřej Surý <ondrej@debian.org>  Sun, 28 Oct 2018 22:20:23 +0000

libgd2 (2.2.5-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Potential infinite loop in gdImageCreateFromGifCtx (CVE-2018-5711)
    (Closes: #887485)
  * bmp: check return value in gdImageBmpPtr (CVE-2018-1000222)
    (Closes: #906886)
  * Remove src/Makefile.am patching in
    tests-make-a-little-change-for-autopkgtest.patch.  Fixes "libgd2 FTBFS:
    cannot find -lgd".
    Thanks to Helmut Grohne and Adrian Bunk (Closes: #906840)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 06 Oct 2018 00:22:59 +0200

## libgd2 2.3.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.7 FATAL_ERROR)

SET(PACKAGE GD)
SET(PACKAGE_NAME GD)

PROJECT(GD)

SET(CMAKE_MODULE_PATH "${GD_SOURCE_DIR}/cmake/modules")

include(gd)

OPTION(ENABLE_GD_FORMATS "Enable GD image formats" 0)
OPTION(ENABLE_PNG "Enable PNG support" 0)
OPTION(ENABLE_LIQ "Enable libimagequant support" 0)
OPTION(ENABLE_JPEG "Enable JPEG support" 0)
OPTION(ENABLE_TIFF "Enable TIFF support" 0)
OPTION(ENABLE_ICONV "Enable ICONV support" 0)
OPTION(ENABLE_XPM "Enable XPM support" 0)
OPTION(ENABLE_FREETYPE "Enable Freetype2 support" 0)
OPTION(ENABLE_FONTCONFIG "Enable FontConfig support" 0)
OPTION(ENABLE_WEBP "Enable WebP support" 0)
OPTION(ENABLE_RAQM "Enable RAQM support" 0)

if (BUILD_TEST)
	ENABLE_TESTING()
endif(BUILD_TEST)

# if you would like to pass C flags to the compiler, then just
# - specify -DCMAKE_C_FLAGS=... on invocation of cmake, or
# - specify CFLAGS=... on invocation of make
IF(CMAKE_COMPILER_IS_GNUCC)
  SET(CMAKE_C_FLAGS_DEBUG "-g -Wall -Wextra -O0") # will be added to CMAKE_C_FLAGS when CMAKE_BUILD_TYPE is "Debug"
ENDIF(CMAKE_COMPILER_IS_GNUCC)
SET (CMAKE_LIBRARY_OUTPUT_DIRECTORY
  ${PROJECT_BINARY_DIR}/Bin
  CACHE PATH
  "Single Directory for all Libraries"
  )

# --------- Setup the Executable output Directory -------------
SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY
  ${PROJECT_BINARY_DIR}/Bin
  CACHE PATH
  "Single Directory for all Executables."
  )

# --------- Setup the Executable output Directory -------------
SET (CMAKE_ARCHIVE_OUTPUT_DIRECTORY
  ${PROJECT_BINARY_DIR}/Bin
  CACHE PATH
  "Single Directory for all static libraries."
  )

if (USE_EXT_GD)
	message("Using GD at: ${USE_EXT_GD}")
	INCLUDE_DIRECTORIES(BEFORE ${GD_INCLUDE_DIR})
	FIND_PACKAGE(GD)
	if (GD_FOUND)
		INCLUDE_DIRECTORIES(BEFORE ${GD_INCLUDE_DIR})
		LINK_DIRECTORIES(${GD_LIBRARIES})
		SET(GD_LIB ${GD_LIBRARIES})
		SET(GD_LIBS_DIR ${GD_LIBRARY})

		message("GD libs #: ${GD_LIBRARIES}")
		message("GD lib #: ${GD_LIBRARY}")
		message("GD include: ${GD_INCLUDE_DIR}")
	else (GD_FOUND)
		message("No gd found")
	endif (GD_FOUND)
else (USE_EXT_GD)

	MACRO(GV VER VAR)
		execute_process(
			COMMAND perl ${CMAKE_CURRENT_SOURCE_DIR}/config/getver.pl ${VER}
			OUTPUT_VARIABLE ${VAR}
		)
	ENDMACRO(GV)

	GV(MAJOR GDLIB_MAJOR)
	GV(MINOR GDLIB_MINOR)
	GV(RELEASE GDLIB_REVISION)
	GV(EXTRA GDLIB_EXTRA)
	SET(GDLIB_VERSION "${GDLIB_MAJOR}.${GDLIB_MINOR}.${GDLIB_REVISION}${GDLIB_EXTRA}")
	MESSAGE(STATUS "gd version ${GDLIB_VERSION}")

	MACRO(GV_LT VER VAR)
		execute_process(
			COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/config/getlib.sh ${VER}
			OUTPUT_VARIABLE ${VAR}
		)
	ENDMACRO(GV_LT)

	GV_LT(SONAME GDLIB_LIB_SOVERSION)
	GV_LT(VERSION GDLIB_LIB_VERSION)
	MESSAGE(STATUS "gd shared lib version ${GDLIB_LIB_SOVERSION} (${GDLIB_LIB_VERSION})")

	SET(CMAKE_REQUIRED_INCLUDES "/usr/include" "/usr/local/include")

	include(CheckIncludeFiles)
	include(CheckIncludeFile)

	include(AC_HEADER_STDC)
	include(CheckPrototypeExists)

	if (ENABLE_PNG)
		FIND_PACKAGE(PNG REQUIRED)
	endif (ENABLE_PNG)

	if (ENABLE_ICONV)
		FIND_PACKAGE(ICONV REQUIRED)
	endif (ENABLE_ICONV)

	FIND_PACKAGE(ZLIB)

	IF (ENABLE_WEBP)
		FIND_PACKAGE(WEBP)
	ENDIF (ENABLE_WEBP)

	IF (ENABLE_LIQ)
		FIND_PACKAGE(LIQ)
	ENDIF (ENABLE_LIQ)

	IF (NOT WIN32)
		FIND_PACKAGE(PTHREAD)
	ENDIF (NOT WIN32)

	if (ENABLE_JPEG)
		FIND_PACKAGE(JPEG)
	endif (ENABLE_JPEG)

	if (ENABLE_TIFF)
		FIND_PACKAGE(TIFF)
	endif (ENABLE_TIFF)

	if (ENABLE_FREETYPE)
		FIND_PACKAGE(Freetype)
	endif (ENABLE_FREETYPE)

	if (ENABLE_XPM)
		FIND_PACKAGE(XPM)
	endif (ENABLE_XPM)

	if (ENABLE_FONTCONFIG)
		FIND_PACKAGE(FontConfig)
	endif (ENABLE_FONTCONFIG)

	if (ENABLE_RAQM)
		FIND_PACKAGE(RAQM)
	endif (ENABLE_RAQM)

	SET(ENABLE_GD_FORMATS ${ENABLE_GD_FORMATS})

	if (FREETYPE_FOUND)
		INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS})
		SET(HAVE_FT2BUILD_H 1)
		SET(HAVE_LIBFREETYPE 1)
	ENDIF(FREETYPE_FOUND)

	IF(ZLIB_FOUND)
		INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
		SET(HAVE_LIBZ 1)
	ENDIF(ZLIB_FOUND)

	IF(WEBP_FOUND)
		INCLUDE_DIRECTORIES(${WEBP_INCLUDE_DIR})
		SET(HAVE_LIBWEBP 1)
	ENDIF(WEBP_FOUND)

	IF(PNG_FOUND)
		INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
		SET(HAVE_LIBPNG 1)
	ENDIF(PNG_FOUND)

	IF(ICONV_FOUND)
		INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
		SET(HAVE_ICONV 1)
		SET(HAVE_ICONV_H 1)
	ENDIF(ICONV_FOUND)

	IF(LIQ_FOUND)
		INCLUDE_DIRECTORIES(${LIQ_INCLUDE_DIR})
		SET(HAVE_LIBIMAGEQUANT 1)
	ENDIF(LIQ_FOUND)

	IF(XPM_FOUND)
		INCLUDE_DIRECTORIES(${XPM_INCLUDE_DIR})
		SET(HAVE_LIBXPM 1)
	ENDIF(XPM_FOUND)

	IF(JPEG_FOUND)
		INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
		SET(HAVE_LIBJPEG 1)
	ENDIF(JPEG_FOUND)

	IF(TIFF_FOUND)
		INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
		SET(HAVE_LIBTIFF 1)
	ENDIF(TIFF_FOUND)

	IF(FONTCONFIG_FOUND)
		INCLUDE_DIRECTORIES(${FONTCONFIG_INCLUDE_DIR})
		SET(HAVE_LIBFONTCONFIG 1)
	ELSE (FONTCONFIG_FOUND)
		SET(FONTCONFIG_LIBRARY "")
		SET(FONTCONFIG_INCLUDE_DIR "")
		SET(FONTCONFIG_LIB_DIR "")
	ENDIF(FONTCONFIG_FOUND)

	IF(RAQM_FOUND)
		INCLUDE_DIRECTORIES(${RAQM_INCLUDE_DIR})
	ENDIF(RAQM_FOUND)

	SET(HAVE_CONFIG_H 1)

	ADD_DEFINITIONS(-DHAVE_CONFIG_H)

	CHECK_INCLUDE_FILE("stdint.h"	HAVE_STDINT_H)
	CHECK_INCLUDE_FILE("inttypes.h"	HAVE_INTTYPES_H)

	CONFIGURE_FILE(${GD_SOURCE_DIR}/src/config.h.cmake ${GD_SOURCE_DIR}/src/config.h ESCAPE_QUOTES)

	option(BUILD_SHARED_LIBS "Build shared libs" ON)
	option(BUILD_STATIC_LIBS "Build static libs" OFF)

	if (WIN32)
		SET(GD_LIB libgd)
		ADD_DEFINITIONS( -DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32 -DWINVER=0x0500  -D_WIN32_WINNT=0x0500 -D_WIN32_IE=0x0600)

		if(NOT MINGW AND MSVC_VERSION GREATER 1399)
			ADD_DEFINITIONS("/D_CRT_SECURE_NO_DEPRECATE")
		endif(NOT MINGW AND MSVC_VERSION GREATER 1399)
		if (MINGW OR MSYS)
			ADD_DEFINITIONS("-mms-bitfields") # -m32
		endif (MINGW OR MSYS)
	else (WIN32)
		SET(GD_LIB gd)
	endif (WIN32)

	SET(GD_LIB_STATIC "${GD_LIB}_static")

	IF(PROFILE)
		add_definitions("-pg")
		set(CMAKE_EXE_LINKER_FLAGS ${LINK_FLAGS} "-pg")
	ENDIF(PROFILE)

	SET(GD_INCLUDE_DIR "${GD_SOURCE_DIR}/src" "${GD_SOURCE_DIR}")
	INCLUDE_DIRECTORIES(before ${FONTCONFIG_INCLUDE_DIR})

	add_subdirectory(src)
endif (USE_EXT_GD)

add_subdirectory(tests)
add_subdirectory(examples)

add_custom_target(distclean ${GD_SOURCE_DIR}/cmake/distclean.sh)

SET(CPACK_PACKAGE_NAME "libgd")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "libGD, powerful and easy to use graphic library")
SET(CPACK_PACKAGE_VENDOR "https://www.libgd.org")
SET(CPACK_PACKAGE_VERSION_MAJOR ${GDLIB_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${GDLIB_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${GDLIB_REVISION}${GDLIB_EXTRA})

if(WIN32)
	set(CPACK_GENERATOR ZIP)
else(WIN32)
	set(CPACK_GENERATOR TGZ)
endif(WIN32)


INSTALL(FILES docs/INSTALL DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES docs/README.JPN DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES docs/README.CMAKE DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES docs/README.TESTING DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES docs/README.TXT DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})


INSTALL(FILES examples/arc.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/copyrotated.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/crop.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/flip.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/gif.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/nnquant.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/noIcon.pic DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/noIcon.sgi DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/noIcon.tga DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/noIconAlpha.tga DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/test_crop_threshold.png DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/tgaread.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/tiffread.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})
INSTALL(FILES examples/windows.c DESTINATION share/doc/gd-${GDLIB_MAJOR}.${GDLIB_MINOR})


set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")

set(CPACK_SOURCE_GENERATOR TGZ)
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"\\\\.swp$"
"\\\\.gitignore$"
"^${PROJECT_SOURCE_DIR}/debian/"
"^${PROJECT_SOURCE_DIR}/old/"
"^${PROJECT_SOURCE_DIR}/bld/"
)
install(FILES ${top_level_DOCFILES} DESTINATION ${DOC_DIR})
INCLUDE(CPack)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 if (BUILD_TEST)
 	SET(DART_TESTING_TIMEOUT 5)
 
@@ -28,15 +27,21 @@
 		gdimageclone
 		gdimagecolor
 		gdimagecolorclosest
+		gdimagecolorclosesthwb
 		gdimagecolordeallocate
 		gdimagecolorexact
+		gdimagecolormatch
 		gdimagecolorreplace
 		gdimagecolorresolve
 		gdimagecolortransparent
+		gdimagecompare
 		gdimagecontrast
 		gdimageconvolution
 		gdimagecopy
+		gdimagecopymerge
+		gdimagecopymergegray
 		gdimagecopyresampled
+		gdimagecopyresized
 		gdimagecopyrotated
 		gdimagecreate
 		gdimagecrop
@@ -49,6 +54,7 @@
 		gdimagefilltoborder
 		gdimagefilter
 		gdimageflip
+		gdimageellipse
 		gdimagegrayscale
 		gdimageline
 		gdimagenegate
@@ -59,15 +65,22 @@
 		gdimagerotate
 		gdimagescale
 		gdimagescatterex
+		gdimagesetinterpolationmethod
 		gdimagesetpixel
+		gdimagesquaretocircle
+		gdimagestring
+		gdimagestring16
 		gdimagestringft
 		gdimagestringftex
+		gdimagestringup
+		gdimagestringup16
 		gdimagetruecolortopalette
 		gdinterpolatedscale
 		gdnewfilectx
 		gdtest
 		gdtiled
 		gdtransformaffineboundingbox
+		gdtransformaffinecopy
 		gif
 		jpeg
 		png

=== tests/gdimagecolorclosesthwb/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	gdImageColorClosestHWB
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagecompare/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	gdimagecompare
)
ADD_GD_TESTS()

=== tests/gdimagecopy/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bug00007
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00081
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimageellipse/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00169
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagefilledarc/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00351
	php_bug43828
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagefilltoborder/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bug00037
	github_bug_215
)

ADD_GD_TESTS()

=== tests/gdimageline/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	gdimageline_aa_outofrange
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00077
	bug00072
	bug00111
	bug00315
	gdimageline_aa
	gdimageline_bug5
	gdImageAALine_thickness
	github_bug_167
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagestringft/CMakeLists.txt ===
IF(FREETYPE_FOUND)
LIST(APPEND TESTS_FILES
	gdimagestringft_bbox
)
ENDIF(FREETYPE_FOUND)

ADD_GD_TESTS()

=== tests/gdimagestringup16/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	gdimagestringup16
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gif/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	bug00005_2
	bug00181
	bug00227
	bug00499
	gif_null
	ossfuzz5700
	php_bug_75571
	uninitialized_memory_read
	bug00006
	bug00060
	gif_im2im
)

IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00005
	bug00066
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== debian/changelog ===
libgd2 (2.3.0-2ubuntu2) jammy; urgency=medium

  * No-change rebuild against latest libwebp

 -- Jeremy Bicha <jeremy.bicha@canonical.com>  Tue, 01 Feb 2022 09:24:16 -0500

libgd2 (2.3.0-2ubuntu1) impish; urgency=medium

  * SECURITY UPDATE: Out-of-bounds read
    - debian/patches/CVE-2021-38115.patch: fix a read out-of-bounds in
      reading tga header file in src/gd_tga.c.
    - CVE-2021-38115
  * SECURITY UPDATE: Double free
    - debian/patches/CVE-2021-40145-*.patch: fix a memory leak in
      src/gd_gd2.c.
    - CVE-2021-40145

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 09 Sep 2021 09:29:48 -0300

libgd2 (2.3.0-2) unstable; urgency=medium

  * Add patch to fix gdImageStringFT() fails for empty strings
    (Closes: #959591)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 06 May 2020 16:11:29 +0200

libgd2 (2.3.0-1) unstable; urgency=medium

  * New upstream version 2.3.0

 -- Ondřej Surý <ondrej@debian.org>  Fri, 24 Apr 2020 09:41:29 +0200

libgd2 (2.2.5-5.2) unstable; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2019-11038: Uninitialized read in gdImageCreateFromXbm
    (Closes: #929821)

 -- Jonas Meurer <jonas@freesources.org>  Tue, 11 Jun 2019 16:21:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libgd2
 Section: graphics
 Priority: optional
-Maintainer: GD team <pkg-gd-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: GD Team <team+gd@tracker.debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Build-Depends: autotools-dev,
-	       debhelper (>= 9),
+	       debhelper (>= 9.20150101~),
 	       libpng-dev,
 	       libz-dev,
 	       libjpeg-dev,
@@ -17,8 +18,8 @@
 	       libtiff-dev,
 	       dh-autoreconf,
 	       html2text
-Vcs-Git: git://anonscm.debian.org/collab-maint/libgd2.git
-Vcs-Browser: http://anonscm.debian.org/gitweb?p=collab-maint/libgd2.git;a=summary
+Vcs-Git: https://salsa.debian.org/debian/libgd2.git
+Vcs-Browser: https://salsa.debian.org/debian/libgd2
 Standards-Version: 3.9.3
 Homepage: http://www.libgd.org/

## libgd2 2.3.3

=== src/CMakeLists.txt ===
SET (LIBGD_SRC_FILES
	gd.c
	gd_avif.c
	gd_bmp.c
	gd_color.c
	gd_color_map.c
	gd_color_match.c
	gd_crop.c
	gd_filename.c
	gd_filter.c
	gd_gd.c
	gd_gd2.c
	gd_gif_in.c
	gd_gif_out.c
	gd_heif.c
	gd_interpolation.c
	gd_io.c
	gd_io_dp.c
	gd_io_file.c
	gd_io_ss.c
	gd_io_stream.cxx
	gd_jpeg.c
	gd_matrix.c
	gd_nnquant.c
	gd_png.c
	gd_rotate.c
	gd_security.c
	gd_ss.c
	gd_tga.c
	gd_tiff.c
	gd_topal.c
	gd_transform.c
	gd_version.c
	gd_wbmp.c
	gd_webp.c
	gd_xbm.c
	gdcache.c
	gdfontg.c
	gdfontl.c
	gdfontmb.c
	gdfonts.c
	gdfontt.c
	gdft.c
	gdfx.c
	gdhelpers.c
	gdkanji.c
	gdpp.cxx
	gdtables.c
	gdxpm.c
	wbmp.c
)

# Static library just for utility programs.
SET (GD_PROGRAMS_LIB_SRC_FILES)

if(MSVC)
	set(GD_PROGRAMS_LIB_SRC_FILES ${GD_PROGRAMS_LIB_SRC_FILES}
		getopt.c
	)
endif(MSVC)

include(GNUInstallDirs)

if (BUILD_SHARED_LIBS)
	add_library(${GD_LIB} ${LIBGD_SRC_FILES})
	set_target_properties(${GD_LIB} PROPERTIES
		SOVERSION ${GDLIB_LIB_SOVERSION}
		VERSION ${GDLIB_LIB_VERSION}
		C_VISIBILITY_PRESET hidden
		CXX_VISIBILITY_PRESET hidden
	)
endif()

if (BUILD_STATIC_LIBS)
	add_library(${GD_LIB_STATIC} STATIC ${LIBGD_SRC_FILES})
	if (UNIX)
		set_target_properties(${GD_LIB_STATIC} PROPERTIES OUTPUT_NAME ${GD_LIB})
	endif()
endif()

if (NOT "${GD_PROGRAMS_LIB_SRC_FILES}" STREQUAL "")
	add_library(gd_programs_lib STATIC ${GD_PROGRAMS_LIB_SRC_FILES})
endif()

if (WIN32 AND NOT MINGW AND NOT MSYS)
  #	SET_TARGET_PROPERTIES(${GD_LIB} PROPERTIES LINK_FLAGS "/NODEFAULTLIB:msvcrt.lib")

  if (BUILD_STATIC_LIBS)
    SET_PROPERTY(TARGET ${GD_LIB_STATIC} APPEND PROPERTY COMPILE_DEFINITIONS NONDLL=1)
  endif()

ENDIF(WIN32 AND NOT MINGW AND NOT MSYS)

if (MINGW OR MSYS)
	ADD_DEFINITIONS("-mms-bitfields")
	if (BUILD_STATIC_LIBS)
		set_target_properties(${GD_LIB_STATIC} PROPERTIES OUTPUT_NAME ${GD_LIB})
	endif()
endif (MINGW OR MSYS)

INCLUDE_DIRECTORIES(BEFORE "${PROJECT_BINARY_DIR}" "${CMAKE_BINARY_DIR}" "${GD_SOURCE_DIR}/src")

SET(LIBGD_DEP_LIBS
	${ZLIB_LIBRARIES}
	${FREETYPE_LIBRARIES}
	${PNG_LIBRARIES}
	${ICONV_LIBRARIES}
	${LIQ_LIBRARIES}
	${JPEG_LIBRARIES}
	${TIFF_LIBRARIES}
	${XPM_LIBRARIES}
	${FONTCONFIG_LIBRARY}
	${WEBP_LIBRARIES}
	${AVIF_LIBRARIES}
	${RAQM_LIBRARIES}
	${HEIF_LIBRARIES}
)
if (BUILD_SHARED_LIBS)
	target_link_libraries(${GD_LIB} ${LIBGD_DEP_LIBS})
endif()
if (BUILD_STATIC_LIBS)
	target_link_libraries(${GD_LIB_STATIC} ${LIBGD_DEP_LIBS})
endif()

SET(LIBS_PRIVATES
	${ICONV_LIBRARIES}
	${LIQ_LIBRARIES}
	${WEBP_LIBRARIES}
)

set(GD_PROGRAMS gdcmpgif)

if (PNG_FOUND)
	set(GD_PROGRAMS ${GD_PROGRAMS} gdtopng pngtogd)
	if (NOT WIN32)
		set(GD_PROGRAMS ${GD_PROGRAMS} webpng)
	endif (NOT WIN32)
	if (ZLIB_FOUND)
		set(GD_PROGRAMS ${GD_PROGRAMS} gdparttopng gd2topng pngtogd2)
	endif()
endif()

if (FREETYPE_FOUND AND JPEG_FOUND)
	if (NOT WIN32)
		set(GD_PROGRAMS ${GD_PROGRAMS} annotate)
	endif (NOT WIN32)
endif()

if (ZLIB_FOUND)
	set(GD_PROGRAMS ${GD_PROGRAMS} gd2copypal gd2togif giftogd2)
endif()

foreach(program ${GD_PROGRAMS})
    add_executable(${program} ${program}.c)
	if (WIN32)
		list(REMOVE_ITEM program webpng.c annotate.c)
		list(REMOVE_ITEM GD_PROGRAMS webpng)
		list(REMOVE_ITEM GD_PROGRAMS annotate)
	endif (WIN32)

    if (BUILD_SHARED_LIBS)
        target_link_libraries(${program} ${GD_LIB})
    else()
        target_link_libraries(${program} ${GD_LIB_STATIC})
    endif()
	if (NOT "${GD_PROGRAMS_LIB_SRC_FILES}" STREQUAL "")
		target_link_libraries(${program} gd_programs_lib)
	endif()
endforeach(program)

set(GD_INSTALL_TARGETS ${GD_PROGRAMS})
if (BUILD_SHARED_LIBS)
	set(GD_INSTALL_TARGETS ${GD_INSTALL_TARGETS} ${GD_LIB})
endif()
if (BUILD_STATIC_LIBS)
	set(GD_INSTALL_TARGETS ${GD_INSTALL_TARGETS} ${GD_LIB_STATIC})
endif()

install(TARGETS ${GD_INSTALL_TARGETS}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(PROGRAMS bdftogd DESTINATION bin)
install(FILES
	gd.h
	gd_color_map.h
	gd_errors.h
	gd_io.h
	gdcache.h
	gdfontg.h
	gdfontl.h
	gdfontmb.h
	gdfonts.h
	gdfontt.h
	gdfx.h
	gdpp.h
	DESTINATION include)

CONFIGURE_FILE(../config/gdlib.pc.cmake gdlib.pc @ONLY)
INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/gdlib.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== tests/fontconfig/CMakeLists.txt ===
if(FONTCONFIG_FOUND)
IF(FREETYPE_FOUND)
LIST(APPEND TESTS_FILES
    basic
)
ENDIF(FREETYPE_FOUND)
ENDIF(FONTCONFIG_FOUND)

ADD_GD_TESTS()

=== tests/gd/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	gd_versiontest
)

IF(ENABLE_GD_FORMATS)
LIST(APPEND TESTS_FILES
	bug00383
	gd_null
	gd_num_colors
	gd_im2im
)
ENDIF(ENABLE_GD_FORMATS)

ADD_GD_TESTS()

=== tests/gdcolormaplookup/CMakeLists.txt ===
if (NOT WIN32)
LIST(APPEND TESTS_FILES
	gdcolormaplookup
)
endif (NOT WIN32)
ADD_GD_TESTS()

=== tests/gdimagearc/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00079
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagefile/CMakeLists.txt ===
IF(TIFF_FOUND)
IF(WEBP_FOUND)
IF(ENABLE_GD_FORMATS)
LIST(APPEND TESTS_FILES
	gdnametest
)
ENDIF(ENABLE_GD_FORMATS)
ENDIF(WEBP_FOUND)
ENDIF(TIFF_FOUND)

ADD_GD_TESTS()

=== tests/gdimagefilledellipse/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	bug00010
	bug00169
	bug00191
	github_bug_00238
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()

=== tests/gdimagesetinterpolationmethod/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	github_bug_00584
)

ADD_GD_TESTS()

=== tests/gdinterpolatedscale/CMakeLists.txt ===
LIST(APPEND TESTS_FILES
	gdModesAndPalettes
	gdTrivialResize
)

ADD_GD_TESTS()

# Probably should speed this test up.
set_tests_properties(test_${TEST_PREFIX}_gdTrivialResize PROPERTIES TIMEOUT 20)

=== tests/tiff/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,13 @@
 	tiff_invalid_read
 	tiff_null
 	tiff_dpi
+)
+
+IF(PNG_FOUND)
+LIST(APPEND TESTS_FILES
 	tiff_read_bw
 )
+ENDIF(PNG_FOUND)
 ENDIF(TIFF_FOUND)
 
 ADD_GD_TESTS()

=== tests/webp/CMakeLists.txt ===
IF(WEBP_FOUND)
LIST(APPEND TESTS_FILES
	bug00111
	gdImageWebpEx
	webp_ll_im2im
)
IF(JPEG_FOUND)
LIST(APPEND TESTS_FILES
	bug_double_free
)
ENDIF(JPEG_FOUND)
ENDIF(WEBP_FOUND)

ADD_GD_TESTS()

=== debian/changelog ===
libgd2 (2.3.3-9ubuntu5) noble; urgency=medium

  * d/control: restore libheif-dev dependency (LP: #2061090).
    Remaining changes:
    - Drop the dependencies on libavif, libavif has an extensive rust
      dependency tree that makes it unsuitable for main.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 16 Apr 2024 20:23:30 +1200

libgd2 (2.3.3-9ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:49:00 +0000

libgd2 (2.3.3-9ubuntu3) noble; urgency=medium

  * Rebuild against new libpng16-16t64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 19 Mar 2024 14:18:01 +0100

libgd2 (2.3.3-9ubuntu2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:03:22 +0000

libgd2 (2.3.3-9ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop the dependencies on libavif and libheif; libheif is blocked on a
      Main Inclusion Request, and libavif has an extensive rust dependency
      tree that makes it unsuitable for main.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 05 May 2023 09:44:27 +0200

libgd2 (2.3.3-9) unstable; urgency=medium

  * Update the B-D to libfreetype-dev

 -- Ondřej Surý <ondrej@debian.org>  Tue, 07 Feb 2023 13:09:24 +0100

libgd2 (2.3.3-8) unstable; urgency=medium

  * Enable back GD_BICUBIC* interpolation methods

 -- Ondřej Surý <ondrej@debian.org>  Tue, 07 Feb 2023 13:04:58 +0100

libgd2 (2.3.3-7ubuntu2) lunar; urgency=medium

  * Rebuild against latest tiff

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 04 Feb 2023 07:28:10 -0500

libgd2 (2.3.3-7ubuntu1) lunar; urgency=medium

  * Drop the dependencies on libavif and libheif; libheif is blocked on a
    Main Inclusion Request, and libavif has an extensive rust dependency tree
    that makes it unsuitable for main.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Nov 2022 23:28:26 +0000

libgd2 (2.3.3-7) unstable; urgency=medium

  * Switch the d/watch to api.github.com
  * Actually enable libavif and libheif support by adding it to Build-Depends

 -- Ondřej Surý <ondrej@debian.org>  Mon, 24 Oct 2022 12:44:39 +0200

libgd2 (2.3.3-6) unstable; urgency=medium

  * Add libwebp-dev to libgd-dev Depends (Closes: #1014759)

 -- Ondřej Surý <ondrej@debian.org>  Sat, 16 Jul 2022 06:25:19 +0200

libgd2 (2.3.3-5) unstable; urgency=medium

  * Reintroduce GD_FLIP constants to fix the API/ABI break

 -- Ondřej Surý <ondrej@debian.org>  Mon, 11 Jul 2022 10:24:25 +0200

libgd2 (2.3.3-4) unstable; urgency=medium

  * Explicitly disable AVIF and HEIF on buster, bionic and focal

 -- Ondřej Surý <ondrej@debian.org>  Thu, 07 Jul 2022 12:49:55 +0200

libgd2 (2.3.3-3) unstable; urgency=medium

  * Add missing libheif-dev and libavif-dev to libgd-dev depends
    (Closes: #1014500)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 07 Jul 2022 06:02:21 +0200

libgd2 (2.3.3-2) unstable; urgency=medium

  * Make the AVIF and HEIF support optional for older Debian and Ubuntu

 -- Ondřej Surý <ondrej@debian.org>  Wed, 06 Jul 2022 16:59:18 +0200

libgd2 (2.3.3-1) unstable; urgency=medium

  * Require debhelper >= 10
  * New upstream version 2.3.3 (Closes: #1004572)
   + CVE-2021-38115: fix read out-of-bands in reading tga header file
     (Closes: #991912)
  * New upstream version 2.3.1
   + CVE-2019-11038: Using uninitialized variables.
   + CVE-2019-6977: Heap-based buffer overflow.
   + CVE-2019-6978: Double-free in gdImage*Ptr().
  * Enable AVIF and HEIF support
  * Update symbols file for libgd3_2.3.3
  * Remove libxt-dev, html2text from build dependencies (Closes: #981208)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 06 Jul 2022 16:33:08 +0200

=== debian/control ===
--- 
+++ 
@@ -4,20 +4,17 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: GD Team <team+gd@tracker.debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
-Build-Depends: autotools-dev,
-	       debhelper (>= 9.20150101~),
-	       libpng-dev,
-	       libz-dev,
-	       libjpeg-dev,
-	       libfreetype6-dev,
-	       libxpm-dev,
-	       libx11-dev,
-	       libxt-dev,
-	       libfontconfig-dev,
-	       libwebp-dev,
-	       libtiff-dev,
-	       dh-autoreconf,
-	       html2text
+Build-Depends: debhelper (>= 10),
+               libfontconfig-dev,
+               libfreetype-dev | libfreetype6-dev,
+               libheif-dev (>= 1.17.6-1ubuntu4~) | base-files (<< 11.1~),
+               libjpeg-dev,
+               libpng-dev,
+               libtiff-dev,
+               libwebp-dev,
+               libx11-dev,
+               libxpm-dev,
+               libz-dev
 Vcs-Git: https://salsa.debian.org/debian/libgd2.git
 Vcs-Browser: https://salsa.debian.org/debian/libgd2
 Standards-Version: 3.9.3
@@ -25,7 +22,9 @@
 
 Package: libgd-tools
 Architecture: any
-Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
+Depends: ${misc:Depends},
+         ${perl:Depends},
+         ${shlibs:Depends}
 Suggests: libgd-dev
 Description: GD command line tools and example code
  GD is a graphics library. It allows your code to quickly draw images
@@ -41,18 +40,19 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libgd3 (= ${binary:Version}),
-	 ${misc:Depends},
-	 libpng-dev,
-	 libz-dev,
-	 libjpeg-dev,
-	 libfreetype6-dev,
-	 libxpm-dev,
-	 libx11-dev,
-	 libxt-dev,
-	 libfontconfig-dev,
-	 libvpx-dev,
-	 libtiff-dev
+Depends: libfontconfig-dev,
+         libfreetype6-dev,
+         libgd3 (= ${binary:Version}),
+         libheif-dev (>= 1.17.6-1ubuntu4~) | base-files (<< 11.1~),
+         libjpeg-dev,
+         libpng-dev,
+         libtiff-dev,
+         libvpx-dev,
+         libwebp-dev,
+         libx11-dev,
+         libxpm-dev,
+         libz-dev,
+         ${misc:Depends}
 Description: GD Graphics Library (development version)
  GD is a graphics library. It allows your code to quickly draw images
  complete with lines, arcs, text, multiple colours, cut and paste from
@@ -67,7 +67,8 @@
 Multi-Arch: same
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: libgd-tools
 Description: GD Graphics Library
  GD is a graphics library. It allows your code to quickly draw images

=== debian/watch ===
# run the "uscan" command to check for upstream updates and more.
version=4
opts="\
	compression=xz, \
	searchmode=plain, \
	uversionmangle=s/RC/~rc/, \
	dversionmangle=s/\~dfsg$//, \
	filenamemangle=s/.+\/libgd-@ANY_VERSION@.tar.xz/@PACKAGE@-$1\.tar\.xz/, \
	"
https://api.github.com/repos/libgd/libgd/releases https://github.com/libgd/libgd/releases/download/gd-(\d\S+)/libgd-(\d\S+).tar.xz
